/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.geometries.textUtils;

import javax.swing.DefaultComboBoxModel;
import org.visnow.vn.geometries.parameters.FontParams;
import org.visnow.vn.geometries.parameters.FontParams.Decoration;
import org.visnow.vn.geometries.parameters.FontParams.Position;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */

public class Text2DGUI extends javax.swing.JPanel
{
    
    private FontParams params;

    /**
     * Creates new form Text2DGUI
     */
    public Text2DGUI()
    {
        initComponents();
        positionCombo.setModel(new DefaultComboBoxModel(Position.values()));
        decorationCombo.setModel(new DefaultComboBoxModel(Decoration.values()));
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        shiftSlider = new org.visnow.vn.gui.widgets.FloatSlider();
        opacitySlider = new org.visnow.vn.gui.widgets.FloatSlider();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));
        jPanel1 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        bgColorEditor = new org.visnow.vn.gui.widgets.ColorEditor();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        positionCombo = new javax.swing.JComboBox<>();
        jLabel2 = new javax.swing.JLabel();
        decorationCombo = new javax.swing.JComboBox<>();

        setLayout(new java.awt.GridBagLayout());

        shiftSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("shift from anchor point"));
        shiftSlider.setMax(3.0F);
        shiftSlider.setShowingFields(false);
        shiftSlider.setVal(1.0F);
        shiftSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                shiftSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(shiftSlider, gridBagConstraints);

        opacitySlider.setBorder(javax.swing.BorderFactory.createTitledBorder("background opacity"));
        opacitySlider.setShowingFields(false);
        opacitySlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                opacitySliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 0);
        add(opacitySlider, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.weighty = 0.6;
        add(filler1, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridLayout(1, 0));

        jLabel4.setText("  background color");
        jPanel1.add(jLabel4);

        bgColorEditor.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                bgColorEditorStateChanged(evt);
            }
        });
        jPanel1.add(bgColorEditor);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jPanel1, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridLayout(2, 0));

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText("position");
        jPanel2.add(jLabel1);

        positionCombo.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        positionCombo.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                positionComboItemStateChanged(evt);
            }
        });
        jPanel2.add(positionCombo);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("decoration");
        jPanel2.add(jLabel2);

        decorationCombo.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        decorationCombo.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                decorationComboItemStateChanged(evt);
            }
        });
        jPanel2.add(decorationCombo);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jPanel2, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void positionComboItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_positionComboItemStateChanged
    {//GEN-HEADEREND:event_positionComboItemStateChanged
        if (params != null)
            params.setPosition((Position)positionCombo.getSelectedItem());
    }//GEN-LAST:event_positionComboItemStateChanged

    private void decorationComboItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_decorationComboItemStateChanged
    {//GEN-HEADEREND:event_decorationComboItemStateChanged
        if (params != null)
            params.setDecoration((Decoration)decorationCombo.getSelectedItem());
    }//GEN-LAST:event_decorationComboItemStateChanged

    private void shiftSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_shiftSliderStateChanged
    {//GEN-HEADEREND:event_shiftSliderStateChanged
        if (params != null)
            params.setShift(shiftSlider.getVal());
    }//GEN-LAST:event_shiftSliderStateChanged

    private void opacitySliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_opacitySliderStateChanged
    {//GEN-HEADEREND:event_opacitySliderStateChanged
        if (params != null)
            params.setOpacity(opacitySlider.getVal());
    }//GEN-LAST:event_opacitySliderStateChanged

    private void bgColorEditorStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_bgColorEditorStateChanged
    {//GEN-HEADEREND:event_bgColorEditorStateChanged
        if (params != null)
            params.setBgColor(bgColorEditor.getColor());
    }//GEN-LAST:event_bgColorEditorStateChanged

    public void setParams( FontParams params)
    {
        this.params = params;
        boolean act = params.isActive();
        params.setActive(false);
        positionCombo.setSelectedItem(params.getPosition());
        decorationCombo.setSelectedItem(params.getDecoration());
        shiftSlider.setVal(params.getShift());
        opacitySlider.setVal(params.getOpacity());
        params.setActive(act);
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.gui.widgets.ColorEditor bgColorEditor;
    private javax.swing.JComboBox<String> decorationCombo;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private org.visnow.vn.gui.widgets.FloatSlider opacitySlider;
    private javax.swing.JComboBox<String> positionCombo;
    private org.visnow.vn.gui.widgets.FloatSlider shiftSlider;
    // End of variables declaration//GEN-END:variables
}
